#include "StdAfx.h"
#include "WASActor.h"
#include "UtilFunction.h"
#include "MessengerActor.h"

#include "WASMyPage.h"
#include "WASListBuddy.h"
#include "WASListBuddyGroup.h"
#include "WASListMember.h"
#include "WASListNameSearch.h"
#include "WASListMemberGroup.h"
#include "WASListTenantDomain.h"
#include "WASUpdateBuddy.h"
#include "WASSearchBuddy.h"
#include "WASListNameSearch.h"
#include "WASGetEmployeeInfo.h"
#include "WASAddGroup.h"
#include "WASDelGroup.h"
#include "WASUpdateGroup.h"
#include "WASUpdateGroupSortOrder.h"
#include "WASRefreshTicket.h"
#include "WASGetUserProfile.h"
#include "WASSetUserProfile.h"
#include "GameTalkAPIGlobal.h"
#include "WASProfileImage.h"
#include "WASRecvMemo.h"
#include "WASGetTalkName.h"
#include "WASGetTotalUsedCapa.h"
#include "WASGetNewRoom.h"
#include "WASGetMyRoomList.h"
#include "WASListNotice.h"
#include "WASListBanner.h"
#include "WASGetHanatourCount.h"
#include "WASListOutLink.h"
#include "WasGetMailCount.h"
#include "WASGetCallHistory.h"
#include "WASSMS.h"
#include "WASSetCallMemo.h"
#include "WASSearchCallHistory.h"
#include "WASSetLang.h"
#include "WASGetLang.h"
#include "WASChangeNotice.h"
#include "WASCheckUpNotice.h"
#include "WASGetMessages.h"

CWASActor::CWASActor(CMessengerActor *pActor) : CActor(pActor)
{
	//CGTLifeLog log(__FUNCTION__);

	m_bAlwaysNewAuthTicketMode = false;
	
	m_pMessengerActor		= pActor;

	m_pWASListBuddy					= new CWASListBuddy(this);
	m_pWASListBuddyGroup			= new CWASListBuddyGroup(this);
	m_pWASListMember				= new CWASListMember(this);
	m_pWASListNameSearch			= new CWASListNameSearch(this);
	m_pWASGetEmployeeInfo			= new CWASGetEmployeeInfo(this);
	m_pWASPrivateGetEmployeeInfo	= new CWASGetEmployeeInfo(this);
	m_pWASListMemberGroup			= new CWASListMemberGroup(this);
	m_pWASListTenantDomain			= new CWASListTenantDomain(this);
	m_pWASGetUserProfile			= new CWASGetUserProfile(this);
	m_pWASSetUserProfile			= new CWASSetUserProfile(this);
	m_pWASMyPage					= new CWASMyPage(this);
	m_pWASUpdateBuddy				= new CWASUpdateBuddy(this);
	m_pWASSearchBuddy				= new CWASSearchBuddy(this);
	m_pWASAddGroup					= new CWASAddGroup(this);
	m_pWASDelGroup					= new CWASDelGroup(this);
	m_pWASUpdateGroup				= new CWASUpdateGroup(this);
	m_pWasUpdateGroupSortOrder		= new CWASUpdateGroupSortOrder(this);
	m_pWASRefreshTicket				= new CWASRefreshTicket(this);
	m_pWASCheckClientNetwork		= new CWASCheckClientNetwork(this);
	//m_pWASSendNote					= new CWASSendNote(this);
	m_pWASUnreadNoteCount			= new CWASUnreadNoteCount(this);
	m_pWASNoteSetReadStatus			= new CWASNoteSetReadStatus(this);
	m_pWASDeleteAttachedFile		= new CWASDeleteAttachedFile(this);
	m_pWASDeleteNote				= new CWASDeleteNote(this);
	m_pWASGetTalkName				= new CWASGetTalkName(this);
	m_pWASGetTotalUsedCapa			= new CWASGetTotalUsedCapa(this);
	//m_pWASGetNewRoom				= new CWASGetNewRoom(this);
	m_pWASGetMyRoomList				= new CWASGetMyRoomList(this);
	m_pWASListNotice				= new CWASListNotice(this);
	m_pWASListBanner				= new CWASListBanner(this);
	m_pWASGetHanatourCount			= new CWASGetHanatourCount(this);
	m_pWASListOutLink				= new CWASListOutLink(this);
	m_pWASGetMailCount				= new CWASGetMailCount(this);
	m_pWASGetMailPreview			= new CWASGetMailPreview(this);
	m_pWASGetCallHistory			= new CWASGetCallHistory(this);
	m_pWASSetCallInfo				= new CWASSetCallInfo(this);
	m_pWASSearchCallHistory			= new CWASSearchCallHistory(this);
	m_pWASSetCallMemo				= new CWASSetCallMemo(this);
	m_pWASSMS						= new CWASSMS(this);
	m_pWASSetLang					= new CWASSetLang(this);
	m_pWASGetLang					= new CWASGetLang(this);
	m_pWASChangeNotice				= new CWASChangeNotice(this);
	m_pWASCheckUpNotice				= new CWASCheckUpNotice(this);
	m_strServerAddr.clear();
}

CWASActor::~CWASActor(void)
{
	//CGTLifeLog log(__FUNCTION__);

	//  ڵ.
	// ִ ִ Ŀǵ   
	// Ȥó  HTTP̺Ʈ ߻Ͽ   Ŀǵ带  õ õ! (׷ ..)
	m_mapCommand.clear();

	SAFE_DELETE(m_pWASListBuddy);
	SAFE_DELETE(m_pWASListBuddyGroup);
	SAFE_DELETE(m_pWASListMember);
	SAFE_DELETE(m_pWASListNameSearch);
	SAFE_DELETE(m_pWASGetEmployeeInfo);
	SAFE_DELETE(m_pWASPrivateGetEmployeeInfo);
	SAFE_DELETE(m_pWASListMemberGroup);
	SAFE_DELETE(m_pWASListTenantDomain);
	SAFE_DELETE(m_pWASGetUserProfile);
	SAFE_DELETE(m_pWASSetUserProfile);
	SAFE_DELETE(m_pWASMyPage);
	SAFE_DELETE(m_pWASUpdateBuddy);
	SAFE_DELETE(m_pWASSearchBuddy);
	SAFE_DELETE(m_pWASAddGroup);
	SAFE_DELETE(m_pWASDelGroup);
	SAFE_DELETE(m_pWASUpdateGroup);
	SAFE_DELETE(m_pWASRefreshTicket);
	//SAFE_DELETE(m_pWASSendNote);
	SAFE_DELETE(m_pWASUnreadNoteCount);
	SAFE_DELETE(m_pWASNoteSetReadStatus);
	SAFE_DELETE(m_pWASDeleteAttachedFile);
	SAFE_DELETE(m_pWASDeleteNote);
	SAFE_DELETE(m_pWASGetTalkName);
	SAFE_DELETE(m_pWASGetTotalUsedCapa);
	//SAFE_DELETE(m_pWASGetNewRoom);
	SAFE_DELETE(m_pWASGetMyRoomList);
	SAFE_DELETE(m_pWASListNotice);
	SAFE_DELETE(m_pWASListBanner);
	SAFE_DELETE(m_pWASGetHanatourCount);
	SAFE_DELETE(m_pWASListOutLink);
	SAFE_DELETE(m_pWASGetMailCount);
	SAFE_DELETE(m_pWASGetMailPreview);
	SAFE_DELETE(m_pWASGetCallHistory);
	SAFE_DELETE(m_pWASSetCallInfo);
	SAFE_DELETE(m_pWASSearchCallHistory);
	SAFE_DELETE(m_pWASSetCallMemo);
	SAFE_DELETE(m_pWASSMS);
	SAFE_DELETE(m_pWASSetLang);
	SAFE_DELETE(m_pWASGetLang);
	SAFE_DELETE(m_pWASChangeNotice);
	SAFE_DELETE(m_pWASCheckUpNotice);

	///////////////////////////////////////////////////////////////////////////////////////////////////////
	//
	// DELETE ALL REMAIN WAS COMMAND
	//
	///////////////////////////////////////////////////////////////////////////////////////////////////////

	//CGTNormLog log2(_T("> REMAIN WAS COMMAND FORCE DELETE : TOT=%d/%d"), m_mapCommand.size(), m_mapCommandForDynamic.size());

	int i = 0;
	wascmdmap_t::iterator it = m_mapCommandForDynamic.begin();
	for(; it != m_mapCommandForDynamic.end(); it++)
	{
		delete it->second;
	}
	m_mapCommandForDynamic.clear();
	///////////////////////////////////////////////////////////////////////////////////////////////////////

//	log.Trace("%s : DELETE ACTOR RESULT => OBSERVER = %d(%d), REF = %d", __FUNCTION__, size(), m_observerPrivate.size(), RetainCount());
//	log.End();
}


bool CWASActor::_HasLoginTicket(void)
{
	if(m_bAlwaysNewAuthTicketMode)
	{
		m_pMessengerActor->GetNewMessengerTicket();	// In this func, new ticket issued..
	}
	
	return m_pMessengerActor->GetMessengerTicket() != NULL && strlen(m_pMessengerActor->GetMessengerTicket()) > 0;
}


bool CWASActor::CancelRequest(trid_t trid)
{
	return CancelCommand(trid);
}



bool CWASActor::RequestBuddyList(LPCWSTR strLangCode, int nCacheSerial, trid_t *pTrid)
{	
	if(!_HasLoginTicket())
		return false;

	trid_t trid = GT_GLOBAL->GetTransactionID(pTrid);

	if(m_pWASListBuddy == NULL)
		m_pWASListBuddy	= new CWASListBuddy(this);

	if (NULL == m_pWASListBuddy)
		return false;

	if(m_pWASListBuddy->IsWorking())
		return false;

	m_pWASListBuddy->SetTransactionID(trid);

    m_pWASListBuddy->SetParameter(strLangCode, nCacheSerial);
    
	m_mapCommand.insert(wascmdmap_t::value_type(trid, m_pWASListBuddy));

	m_pWASListBuddy->ExecuteAsync();

	return true;
}


bool CWASActor::RequestBuddyGroupList(trid_t *pTrid)
{	
	if(!_HasLoginTicket())
		return false;

	trid_t trid = GT_GLOBAL->GetTransactionID(pTrid);

	if(m_pWASListBuddyGroup == NULL)
		m_pWASListBuddyGroup = new CWASListBuddyGroup(this);

	if (NULL == m_pWASListBuddyGroup)
		return false;

	if(m_pWASListBuddyGroup->IsWorking())
		return false;

	m_pWASListBuddyGroup->SetTransactionID(trid);
	
	m_mapCommand.insert(wascmdmap_t::value_type(trid, m_pWASListBuddyGroup));

	m_pWASListBuddyGroup->ExecuteAsync();

	return true;
}

bool CWASActor::RequestCallHistory(NTCallType eCallType, LPCWSTR strLangCode, trid_t *pTrid)
{	
	if(!_HasLoginTicket())
		return false;

	trid_t trid = GT_GLOBAL->GetTransactionID(pTrid);

	if(m_pWASGetCallHistory == NULL)
		m_pWASGetCallHistory = new CWASGetCallHistory(this);

	if (NULL == m_pWASGetCallHistory)
		return false;

	if(m_pWASGetCallHistory->IsWorking())
		return false;

	m_pWASGetCallHistory->SetTransactionID(trid);
	m_pWASGetCallHistory->SetParameter(eCallType, strLangCode);

	m_mapCommand.insert(wascmdmap_t::value_type(trid, m_pWASGetCallHistory));

	m_pWASGetCallHistory->ExecuteAsync();

	return true;
}

bool CWASActor::RequestSetCallInfo(NE_CALL_DATA &sCallData, trid_t *pTrid)
{	
	if(!_HasLoginTicket())
		return false;

	trid_t trid = GT_GLOBAL->GetTransactionID(pTrid);

	if(m_pWASSetCallInfo == NULL)
		m_pWASSetCallInfo = new CWASSetCallInfo(this);

	if (NULL == m_pWASSetCallInfo)
		return false;

	if(m_pWASSetCallInfo->IsWorking())
		return false;

	m_pWASSetCallInfo->SetTransactionID(trid);
	m_pWASSetCallInfo->SetParameter(sCallData);

	m_mapCommand.insert(wascmdmap_t::value_type(trid, m_pWASSetCallInfo));

	m_pWASSetCallInfo->ExecuteAsync();

	return true;
}

bool CWASActor::RequestSearchCallHistory(NTCallType eCallType, LPCWSTR strSearchWord, LPCWSTR strLangCode, trid_t *pTrid)
{	
	if(!_HasLoginTicket())
		return false;

	trid_t trid = GT_GLOBAL->GetTransactionID(pTrid);

	if(m_pWASSearchCallHistory == NULL)
		m_pWASSearchCallHistory = new CWASSearchCallHistory(this);

	if (NULL == m_pWASSearchCallHistory)
		return false;

	if(m_pWASSearchCallHistory->IsWorking())
		return false;

	m_pWASSearchCallHistory->SetTransactionID(trid);
	m_pWASSearchCallHistory->SetParameter(eCallType, strSearchWord, strLangCode);

	m_mapCommand.insert(wascmdmap_t::value_type(trid, m_pWASSearchCallHistory));

	m_pWASSearchCallHistory->ExecuteAsync();

	return true;
}
bool CWASActor::RequestMemberList(int nGroupType, LPCWSTR strParentGrpID, LPCWSTR strGrpID, LPCWSTR strLangCode, trid_t *pTrid)
{	
	if( wcslen(strGrpID) <= 0 )
		return false;

	if(!_HasLoginTicket())
		return false;

	trid_t trid = GT_GLOBAL->GetTransactionID(pTrid);

	if(m_pWASListMember == NULL)
		m_pWASListMember = new CWASListMember(this);

	if (NULL == m_pWASListMember)
		return false;

	if(m_pWASListMember->IsWorking())
		return false;

	m_pWASListMember->SetTransactionID(trid);
	m_pWASListMember->SetParameter(nGroupType, strParentGrpID, strGrpID, strLangCode, GetMessengerActor()->GetFunction());

	m_mapCommand.insert(wascmdmap_t::value_type(trid, m_pWASListMember));

	m_pWASListMember->ExecuteAsync();

	return true;
}

bool CWASActor::RequestNameSearchList(const NE_SEARCH_MEMBER_PARAM& searchParam, trid_t *pTrid)
{
	if (wcslen(searchParam.strSearchText) <= 0)
		return false;

	if (!_HasLoginTicket())
		return false;

	trid_t trid = GT_GLOBAL->GetTransactionID(pTrid);

	if (m_pWASListNameSearch == NULL)
		m_pWASListNameSearch = new CWASListNameSearch(this);

	if (NULL == m_pWASListNameSearch)
		return false;

	if (m_pWASListNameSearch->IsWorking())
		return false;

	m_pWASListNameSearch->SetTransactionID(trid);
	m_pWASListNameSearch->SetParameter(searchParam);

	m_mapCommand.insert(wascmdmap_t::value_type(trid, m_pWASListNameSearch));

	m_pWASListNameSearch->ExecuteAsync();

	return true;
}

bool CWASActor::RequestEmplyeeInfo(LPCWSTR strEmpIDs, LPCWSTR strLangCode, NTRequestEmpInfoType reqEmpInfoType, trid_t *pTrid, int nGroupID)
{
	if(!_HasLoginTicket())
		return false;

	trid_t trid = GT_GLOBAL->GetTransactionID(pTrid);

	if(reqEmpInfoType == reitSingleTrans)
	{
		if(m_pWASGetEmployeeInfo == NULL)
			m_pWASGetEmployeeInfo = new CWASGetEmployeeInfo(this);

		if (NULL == m_pWASGetEmployeeInfo)
			return false;

		if(m_pWASGetEmployeeInfo->IsWorking())
			return false;

		m_pWASGetEmployeeInfo->SetTransactionID(trid);
		m_pWASGetEmployeeInfo->SetParameter(strEmpIDs, reqEmpInfoType, nGroupID, GetMessengerActor()->GetFunction(), strLangCode);

		m_mapCommand.insert(wascmdmap_t::value_type(trid, m_pWASGetEmployeeInfo));

		m_pWASGetEmployeeInfo->ExecuteAsync();
	}
	else
	{
		if(m_pWASPrivateGetEmployeeInfo == NULL)
		{
			m_pWASPrivateGetEmployeeInfo = new CWASGetEmployeeInfo(this);
		}


		if (NULL == m_pWASPrivateGetEmployeeInfo)
			return false;

		m_pWASPrivateGetEmployeeInfo->SetTransactionID(trid);
		m_pWASPrivateGetEmployeeInfo->SetParameter(strEmpIDs, reqEmpInfoType, nGroupID, GetMessengerActor()->GetFunction(), strLangCode);

		m_mapCommand.insert(wascmdmap_t::value_type(trid, m_pWASPrivateGetEmployeeInfo));

		m_pWASPrivateGetEmployeeInfo->ExecuteAsync();

	}

	return true;
}


bool CWASActor::RequestMemberGroupList(int nGroupType, LPCWSTR CustcoID, LPCWSTR strTenant, LPCWSTR strLangCode, trid_t *pTrid)
{
	if( wcslen(CustcoID) <= 0 || wcslen(strTenant) <= 0 )
		return false;

	if(!_HasLoginTicket())
		return false;

	trid_t trid = GT_GLOBAL->GetTransactionID(pTrid);

	if(m_pWASListMemberGroup == NULL)
		m_pWASListMemberGroup = new CWASListMemberGroup(this);

	if (NULL == m_pWASListMemberGroup)
		return false;

	if(m_pWASListMemberGroup->IsWorking())
		return false;

	m_pWASListMemberGroup->SetTransactionID(trid);

	m_pWASListMemberGroup->SetParameter(nGroupType, CustcoID, strTenant, strLangCode);

	m_mapCommand.insert(wascmdmap_t::value_type(trid, m_pWASListMemberGroup));

	m_pWASListMemberGroup->ExecuteAsync();

	return true;
}


bool CWASActor::RequestTenantDomainList(LPCWSTR strTenant, trid_t *pTrid)
{	
	if( wcslen(strTenant) <= 0 )
		return false;

	trid_t trid = GT_GLOBAL->GetTransactionID(pTrid);

	if(m_pWASListTenantDomain == NULL)
		m_pWASListTenantDomain = new CWASListTenantDomain(this);

	if (NULL == m_pWASListTenantDomain)
		return false;

	if(m_pWASListTenantDomain->IsWorking())
		return false;

	m_pWASListTenantDomain->SetTransactionID(trid);
	m_pWASListTenantDomain->SetParameter(strTenant);

	m_mapCommand.insert(wascmdmap_t::value_type(trid, m_pWASListTenantDomain));

	m_pWASListTenantDomain->ExecuteAsync();

	return true;
}

bool CWASActor::RequestGetTotalUsedCapa(trid_t *pTrid)
{
	if(!_HasLoginTicket())
		return false;

	trid_t trid = GT_GLOBAL->GetTransactionID(pTrid);

	if(m_pWASGetTotalUsedCapa == NULL)
		m_pWASGetTotalUsedCapa = new CWASGetTotalUsedCapa(this);

	if (NULL == m_pWASGetTotalUsedCapa)
		return false;

	if(m_pWASGetTotalUsedCapa->IsWorking())
		return false;

	m_pWASGetTotalUsedCapa->SetTransactionID(trid);

	m_mapCommand.insert(wascmdmap_t::value_type(trid, m_pWASGetTotalUsedCapa));

	m_pWASGetTotalUsedCapa->ExecuteAsync();

	return true;

}

bool CWASActor::RequestGetUserProfile(LPCWSTR strUserID, trid_t *pTrid)
{
	if(!_HasLoginTicket())
		return false;

	trid_t trid = GT_GLOBAL->GetTransactionID(pTrid);

	if(m_pWASGetUserProfile == NULL)
		m_pWASGetUserProfile = new CWASGetUserProfile(this);

	if (NULL == m_pWASGetUserProfile)
		return false;

	if(m_pWASGetUserProfile->IsWorking())
		return false;

	m_pWASGetUserProfile->SetTransactionID(trid);
	m_pWASGetUserProfile->SetParameter(strUserID);
	
	m_mapCommand.insert(wascmdmap_t::value_type(trid, m_pWASGetUserProfile));

	m_pWASGetUserProfile->ExecuteAsync();

	return true;
}


bool CWASActor::RequestSetMyUserProfile(const GT_USER_PROFILE_DATA &sInfo, trid_t *pTrid)
{
	if(!_HasLoginTicket())
		return false;

	//  ڽŸ  ϴ.
	if(StringUtil::StrCompare(m_pMessengerActor->GetUserID(), sInfo.strUserID) != 0)
	   return false;

	trid_t trid = GT_GLOBAL->GetTransactionID(pTrid);

	P_GT_USER_PROFILE_DATA sDataPrivate;
	sDataPrivate.Load(sInfo);

	if(m_pWASSetUserProfile == NULL)
		m_pWASSetUserProfile = new CWASSetUserProfile(this);

	if (NULL == m_pWASSetUserProfile)
		return false;

	if(m_pWASSetUserProfile->IsWorking())
		return false;

	m_pWASSetUserProfile->SetTransactionID(trid);
	m_pWASSetUserProfile->SetParameter(sDataPrivate);
	
	m_mapCommand.insert(wascmdmap_t::value_type(trid, m_pWASSetUserProfile));

	m_pWASSetUserProfile->ExecuteAsync();
	return true;
}

bool CWASActor::RequestMyPage(bool bFirstLogin, GTOSType eOSType, WSTRING &strLangCode, WSTRING &strTenantName, int nProfileSerial, int nInviteBuddySerial, int nSpecSerial, trid_t *pTrid)
{	
	if(!_HasLoginTicket())
		return false;

	trid_t trid = GT_GLOBAL->GetTransactionID(pTrid);

	if(m_pWASMyPage == NULL)
		m_pWASMyPage = new CWASMyPage(this);

	if (NULL == m_pWASMyPage)
		return false;

	if(m_pWASMyPage->IsWorking())
		return false;

	m_pWASMyPage->SetTransactionID(trid);
	m_pWASMyPage->SetParameter(bFirstLogin, eOSType, strLangCode, strTenantName, nProfileSerial, nInviteBuddySerial, nSpecSerial);
	
	m_mapCommand.insert(wascmdmap_t::value_type(trid, m_pWASMyPage));

	m_pWASMyPage->ExecuteAsync();

	return true;
}


bool CWASActor::RequestUpdateBuddy(vector< pair<wstring, int> > vecBuddy, int nNewGrpID, trid_t *pTrid)
{
	if(!_HasLoginTicket())
		return false;

	trid_t trid = GT_GLOBAL->GetTransactionID(pTrid);

	if(m_pWASUpdateBuddy == NULL)
		m_pWASUpdateBuddy = new CWASUpdateBuddy(this);

	if (NULL == m_pWASUpdateBuddy)
		return false;

	if(m_pWASUpdateBuddy->IsWorking())
		return false;

	m_pWASUpdateBuddy->SetTransactionID(trid);
	m_pWASUpdateBuddy->SetParameter(vecBuddy, nNewGrpID);
	
	m_mapCommand.insert(wascmdmap_t::value_type(trid, m_pWASUpdateBuddy));

	m_pWASUpdateBuddy->ExecuteAsync();

	return true;
}


bool CWASActor::RequestSearchBuddy(LPCWSTR strBuddyID, trid_t *pTrid)
{
	if(!_HasLoginTicket())
		return false;

	trid_t trid = GT_GLOBAL->GetTransactionID(pTrid);

	if(m_pWASSearchBuddy == NULL)
		m_pWASSearchBuddy = new CWASSearchBuddy(this);

	if (NULL == m_pWASSearchBuddy)
		return false;

	if(m_pWASSearchBuddy->IsWorking())
		return false;

	m_pWASSearchBuddy->SetTransactionID(trid);
	m_pWASSearchBuddy->SetParameter(strBuddyID);
	
	m_mapCommand.insert(wascmdmap_t::value_type(trid, m_pWASSearchBuddy));

	m_pWASSearchBuddy->ExecuteAsync();
	return true;
}


bool CWASActor::RequestAddGroup(LPCWSTR strGroupName, GTBuddyAddGroupType addGroupType, int nSortOrder, trid_t *pTrid)
{
	OutputDebugString( _T("CWASActor::RequestAddGroup ===================================\n") );

	if(!_HasLoginTicket())
		return false;

	trid_t trid = GT_GLOBAL->GetTransactionID(pTrid);

	if(m_pWASAddGroup == NULL)
		m_pWASAddGroup = new CWASAddGroup(this);

	if (NULL == m_pWASAddGroup)
		return false;

	if(m_pWASAddGroup->IsWorking())
		return false;

	m_pWASAddGroup->SetTransactionID(trid);
	m_pWASAddGroup->SetParameter(strGroupName, addGroupType, nSortOrder);
	
	m_mapCommand.insert(wascmdmap_t::value_type(trid, m_pWASAddGroup));

	m_pWASAddGroup->ExecuteAsync();

	return true;
}


bool CWASActor::RequestDelGroup(int nGroupID, trid_t *pTrid)
{
	if(!_HasLoginTicket())
		return false;

	trid_t trid = GT_GLOBAL->GetTransactionID(pTrid);

	if(m_pWASDelGroup == NULL)
		m_pWASDelGroup = new CWASDelGroup(this);

	if (NULL == m_pWASDelGroup)
		return false;

	if(m_pWASDelGroup->IsWorking())
		return false;

	m_pWASDelGroup->SetTransactionID(trid);
	m_pWASDelGroup->SetParameter(nGroupID);
	
	m_mapCommand.insert(wascmdmap_t::value_type(trid, m_pWASDelGroup));

	m_pWASDelGroup->ExecuteAsync();

	return true;
}


bool CWASActor::RequestUpdateGroup(int nGroupID, const GT_BUDDY_GROUP_UPDATABLE_DATA &sInfo, trid_t *pTrid)
{
	if(!_HasLoginTicket())
		return false;

	trid_t trid = GT_GLOBAL->GetTransactionID(pTrid);

	P_GT_BUDDY_GROUP_UPDATABLE_DATA sDataPrivate;
	sDataPrivate.Load(sInfo);

	if(m_pWASUpdateGroup == NULL)
		m_pWASUpdateGroup = new CWASUpdateGroup(this);

	if (NULL == m_pWASUpdateGroup)
		return false;

	if(m_pWASUpdateGroup->IsWorking())
		return false;

	m_pWASUpdateGroup->SetTransactionID(trid);
	m_pWASUpdateGroup->SetParameter(nGroupID, sDataPrivate);
	
	m_mapCommand.insert(wascmdmap_t::value_type(trid, m_pWASUpdateGroup));

	m_pWASUpdateGroup->ExecuteAsync();

	return true;
}

bool CWASActor::RequestUpdateGroupSortOrder(std::vector<GT_BUDDY_GROUP_DATA> &vecGroupData, trid_t *pTrid)
{
	if(!_HasLoginTicket())
		return false;

	trid_t trid = GT_GLOBAL->GetTransactionID(pTrid);

	//P_GT_BUDDY_GROUP_UPDATABLE_DATA sDataPrivate;
	//sDataPrivate.Load(sInfo);

	if(m_pWasUpdateGroupSortOrder == NULL)
		m_pWasUpdateGroupSortOrder = new CWASUpdateGroupSortOrder(this);

	if (NULL == m_pWasUpdateGroupSortOrder)
	{
		ASSERT(false);

		return false;
	}

	if(m_pWasUpdateGroupSortOrder->IsWorking())
	{
		ASSERT(false);
		return false;
	}

	m_pWasUpdateGroupSortOrder->SetTransactionID(trid);
	m_pWasUpdateGroupSortOrder->SetParameter(vecGroupData);

	m_mapCommand.insert(wascmdmap_t::value_type(trid, m_pWasUpdateGroupSortOrder));

	m_pWasUpdateGroupSortOrder->ExecuteAsync();

	return true;
}

bool CWASActor::RequestCheckClientNetwork(trid_t *pTrid)
{
	if(!_HasLoginTicket())
		return false;

	trid_t trid = GT_GLOBAL->GetTransactionID(pTrid);

	if(m_pWASCheckClientNetwork == NULL)
		m_pWASCheckClientNetwork = new CWASCheckClientNetwork(this);

	if (NULL == m_pWASCheckClientNetwork)
		return false;

	if(m_pWASCheckClientNetwork->IsWorking())
		return false;

	m_pWASCheckClientNetwork->SetTransactionID(trid);
	
	m_mapCommand.insert(wascmdmap_t::value_type(trid, m_pWASCheckClientNetwork));

	m_pWASCheckClientNetwork->ExecuteAsync();
	return true;
}

bool CWASActor::RequestRefreshTicket(trid_t *pTrid)
{
	if(!_HasLoginTicket())
	{
		//NTALK_LOG->Debug(L"[LOGIN] HASLOGINTICKET FAILED");
		return false;
	}

	trid_t trid = GT_GLOBAL->GetTransactionID(pTrid);

	if(m_pWASRefreshTicket == NULL)
		m_pWASRefreshTicket = new CWASRefreshTicket(this);

	if (NULL == m_pWASRefreshTicket)
	{
		//NTALK_LOG->Debug(L"[LOGIN] WASREFRESHTICKET INVALID");
		return false;
	}

	if(m_pWASRefreshTicket->IsWorking())
	{
		//NTALK_LOG->Debug(L"[LOGIN] WASREFRESHTICKET ISWORKING");
		return false;
	}

	m_pWASRefreshTicket->SetTransactionID(trid);

	m_mapCommand.insert(wascmdmap_t::value_type(trid, m_pWASRefreshTicket));

	m_pWASRefreshTicket->ExecuteAsync();
	
	return true;
}

bool CWASActor::RequestSendNote(NT_NOTE_SEND_DATA &sSendNoteData, trid_t *pTrid)
{
	if(!_HasLoginTicket())
		return false;

	trid_t trid = GT_GLOBAL->GetTransactionID(pTrid);

	//if(m_pWASSendNote == NULL)
	//	m_pWASSendNote = new CWASSendNote(this);

	//if (NULL == m_pWASSendNote)
	//	return false;

	//if(m_pWASSendNote->IsWorking())
	//	m_pWASSendNote->CancelCommand();

	CWASSendNote *m_pWASSendNote = new CWASSendNote(this);

	m_pWASSendNote->SetTransactionID(trid);
	m_pWASSendNote->SetParameter(&sSendNoteData);

	m_mapCommand.insert(wascmdmap_t::value_type(trid, m_pWASSendNote));

	m_pWASSendNote->ExecuteAsync();

	return true;
}


bool CWASActor::RequestUnreadNoteCount(trid_t *pTrid)
{
	if(!_HasLoginTicket())
		return false;

	trid_t trid = GT_GLOBAL->GetTransactionID(pTrid);

	if(m_pWASUnreadNoteCount == NULL)
		m_pWASUnreadNoteCount = new CWASUnreadNoteCount(this);

	if (NULL == m_pWASUnreadNoteCount)
		return false;

	if(m_pWASUnreadNoteCount->IsWorking())
		return false;

	m_pWASUnreadNoteCount->SetTransactionID(trid);
	
	m_mapCommand.insert(wascmdmap_t::value_type(trid, m_pWASUnreadNoteCount));

	m_pWASUnreadNoteCount->ExecuteAsync();

	return true;
}


bool CWASActor::RequestNoteSetReadStatus(UINT64 nNoteID, LPCSTR strLanguage, trid_t *pTrid)
{
	if(!_HasLoginTicket())
		return false;

	trid_t trid = GT_GLOBAL->GetTransactionID(pTrid);

	if(m_pWASNoteSetReadStatus == NULL)
		m_pWASNoteSetReadStatus = new CWASNoteSetReadStatus(this);

	if (NULL == m_pWASNoteSetReadStatus)
		return false;

	if(m_pWASNoteSetReadStatus->IsWorking())
		return false;

	m_pWASNoteSetReadStatus->SetTransactionID(trid);
	m_pWASNoteSetReadStatus->SetParameter(nNoteID, strLanguage);

	m_mapCommand.insert(wascmdmap_t::value_type(trid, m_pWASNoteSetReadStatus));

	m_pWASNoteSetReadStatus->ExecuteAsync();

	return true;
}


bool CWASActor::RequestGetRecvNoteInfo(UINT64 nNoteID, NTReqNoteInfoType reqType, LPCSTR strLanguage, bool bIncludeToList, trid_t *pTrid)
{
	if(!_HasLoginTicket())
		return false;

	trid_t trid = GT_GLOBAL->GetTransactionID(pTrid);

	CWASGetRecvNoteInfo *pWASGetRecvNoteInfo = new CWASGetRecvNoteInfo(this);

	pWASGetRecvNoteInfo->SetTransactionID(trid);
	pWASGetRecvNoteInfo->SetParameter(nNoteID, reqType, strLanguage, bIncludeToList);

	m_mapCommand.insert(wascmdmap_t::value_type(trid, pWASGetRecvNoteInfo));

	pWASGetRecvNoteInfo->ExecuteAsync();

	return true;
}


bool CWASActor::RequestDelAttachedFile( LPCSTR strAttachID, int nIndex, trid_t *pTrid)
{
	if(!_HasLoginTicket())
		return false;

	trid_t trid = GT_GLOBAL->GetTransactionID(pTrid);

	if(m_pWASDeleteAttachedFile == NULL)
		m_pWASDeleteAttachedFile = new CWASDeleteAttachedFile(this);

	if (NULL == m_pWASDeleteAttachedFile)
		return false;

	if(m_pWASDeleteAttachedFile->IsWorking())
		return false;

	m_pWASDeleteAttachedFile->SetTransactionID(trid);
	m_pWASDeleteAttachedFile->SetParameter(strAttachID, nIndex);

	m_mapCommand.insert(wascmdmap_t::value_type(trid, m_pWASDeleteAttachedFile));

	m_pWASDeleteAttachedFile->ExecuteAsync();

	return true;
}


bool CWASActor::RequestDeleteNote( UINT64 nNoteID, LPCSTR strLanguage, trid_t *pTrid)
{
	if(!_HasLoginTicket())
		return false;

	trid_t trid = GT_GLOBAL->GetTransactionID(pTrid);

	if(m_pWASDeleteNote == NULL)
		m_pWASDeleteNote = new CWASDeleteNote(this);

	if (NULL == m_pWASDeleteNote)
		return false;

	if(m_pWASDeleteNote->IsWorking())
		return false;

	m_pWASDeleteNote->SetTransactionID(trid);
	m_pWASDeleteNote->SetParameter(nNoteID, strLanguage);

	m_mapCommand.insert(wascmdmap_t::value_type(trid, m_pWASDeleteNote));

	m_pWASDeleteNote->ExecuteAsync();

	return true;
}


bool CWASActor::RequestGetAttachID( trid_t *pTrid)
{
	
	if(!_HasLoginTicket())
		return false;

	trid_t trid = GT_GLOBAL->GetTransactionID(pTrid);

	CWASGetAttatchID *pWASGetAttachID = new CWASGetAttatchID(this);
	pWASGetAttachID->SetTransactionID(trid);
	m_mapCommand.insert(wascmdmap_t::value_type(trid, pWASGetAttachID));
	pWASGetAttachID->ExecuteAsync();

	return true;
}


bool CWASActor::RequestGetReplyBody( LPCWSTR strWriteMode, UINT64 nNoteID, LPCSTR strLanguage, trid_t *pTrid)
{
	if(!_HasLoginTicket())
		return false;

	trid_t trid = GT_GLOBAL->GetTransactionID(pTrid);

	CWASGetReplyBody *pWASGetReplyBody = new CWASGetReplyBody(this);;
	pWASGetReplyBody->SetTransactionID(trid);
	pWASGetReplyBody->SetParameter(strWriteMode, nNoteID, strLanguage);

	m_mapCommand.insert(wascmdmap_t::value_type(trid, pWASGetReplyBody));

	pWASGetReplyBody->ExecuteAsync();

	return true;
}


bool CWASActor::RequestProfileImageProfile(bool bUpload, const GT_PROFILE_IMAGE_DATA &sData, DWORD dwUserData1, DWORD dwUserData2, trid_t *pTrid)
{
	if(!_HasLoginTicket())
		return false;

	trid_t trid = GT_GLOBAL->GetTransactionID(pTrid);

	P_GT_PROFILE_IMAGE_DATA sDataPrivate;
	sDataPrivate.Load(sData);

    CWASProfileImage *pWASProfileImage = new CWASProfileImage(this);

	if (NULL == pWASProfileImage)
		return false;

	if(pWASProfileImage->IsWorking())
		return false;

	pWASProfileImage->SetTransactionID(trid);
	pWASProfileImage->SetParameter(bUpload, sDataPrivate, dwUserData1, dwUserData2);
	
	m_mapCommand.insert(wascmdmap_t::value_type(trid, pWASProfileImage));

	pWASProfileImage->ExecuteAsync();

	return true;
}

bool CWASActor::RequestGetNewRoom(LPCTSTR pszCid, LPCTSTR pszCName, LPCTSTR pszBid, LPCTSTR pszBName, trid_t *pTrid)
{
	if(!_HasLoginTicket())
	{
		//NTALK_LOG->Debug(L"[CHAT] REQNEWROOM - TICKET ERROR");
		return false;
	}

	trid_t trid = GT_GLOBAL->GetTransactionID(pTrid);

	CWASGetNewRoom *pWASGetNewRoom = new CWASGetNewRoom(this);

	pWASGetNewRoom->SetTransactionID(trid);
	
	m_mapCommand.insert(wascmdmap_t::value_type(trid, pWASGetNewRoom));

	//Game :  ϱ
	pWASGetNewRoom->SetParameter(pszCid, pszCName, pszBid, pszBName);
	pWASGetNewRoom->ExecuteAsync();

	return true;
}

bool CWASActor::RequestGetMessages(int nRoomId, int nJoinSeq, int nFromMsgNum, int nToMsgNum, int nSendSuccess, trid_t *pTrid)
{
	if(!_HasLoginTicket())
		return false;

	trid_t trid = GT_GLOBAL->GetTransactionID(pTrid);

	CWASGetMessages *pWASGetMessages = new CWASGetMessages(this);

	pWASGetMessages->SetTransactionID(trid);

	m_mapCommand.insert(wascmdmap_t::value_type(trid, pWASGetMessages));

	pWASGetMessages->SetParameter(nRoomId, nJoinSeq, nFromMsgNum, nToMsgNum, nSendSuccess);
	pWASGetMessages->ExecuteAsync();

	return true;
}

bool CWASActor::RequestGetMyRoomList(LPCWSTR strLangCode, trid_t *pTrid)
{
	if(!_HasLoginTicket())
		return false;

	trid_t trid = GT_GLOBAL->GetTransactionID(pTrid);

	if(m_pWASGetMyRoomList == NULL)
		m_pWASGetMyRoomList = new CWASGetMyRoomList(this);

	if (NULL == m_pWASGetMyRoomList)
		return false;

	if(m_pWASGetMyRoomList->IsWorking())
		return false;

	m_pWASGetMyRoomList->SetTransactionID(trid);
	
	m_mapCommand.insert(wascmdmap_t::value_type(trid, m_pWASGetMyRoomList));	
	
	m_pWASGetMyRoomList->SetParameter(strLangCode);
	m_pWASGetMyRoomList->ExecuteAsync();

	return true;
}

bool CWASActor::RequestGetTalkName(LPCTSTR strEmpIDs, trid_t *pTrid)
{
	if( wcslen(strEmpIDs) <= 0 )
		return false;

	if(!_HasLoginTicket())
		return false;
	
	trid_t trid = GT_GLOBAL->GetTransactionID(pTrid);
	
	if(m_pWASGetTalkName == NULL)
		m_pWASGetTalkName = new CWASGetTalkName(this);

	if (NULL == m_pWASGetTalkName)
		return false;
	
	if(m_pWASGetTalkName->IsWorking())
		return false;
	
	m_pWASGetTalkName->SetTransactionID(trid);
	m_pWASGetTalkName->SetParameter(strEmpIDs);
	
	m_mapCommand.insert(wascmdmap_t::value_type(trid, m_pWASGetTalkName));
	m_pWASGetTalkName->ExecuteAsync();
	
	return true;
}

bool CWASActor::RequestSetCallMemo(int nCallSeq, LPCWSTR strMemo, trid_t *pTrid)
{
	if(!_HasLoginTicket())
		return false;

	trid_t trid = GT_GLOBAL->GetTransactionID(pTrid);

	if(m_pWASSetCallMemo == NULL)
		m_pWASSetCallMemo = new CWASSetCallMemo(this);

	if (NULL == m_pWASSetCallMemo)
		return false;

	if(m_pWASSetCallMemo->IsWorking())
		return false;

	m_pWASSetCallMemo->SetParameter(nCallSeq, strMemo);
	m_pWASSetCallMemo->SetTransactionID(trid);

	m_mapCommand.insert(wascmdmap_t::value_type(trid, m_pWASSetCallMemo));

	m_pWASSetCallMemo->ExecuteAsync();

	return true;
}

bool CWASActor::RequestListNotice(trid_t *pTrid)
{
	if(!_HasLoginTicket())
		return false;

	trid_t trid = GT_GLOBAL->GetTransactionID(pTrid);

	if(m_pWASListNotice == NULL)
		m_pWASListNotice = new CWASListNotice(this);

	if (NULL == m_pWASListNotice)
		return false;

	if(m_pWASListNotice->IsWorking())
		return false;
    
	m_pWASListNotice->SetTransactionID(trid);
	
	
	m_mapCommand.insert(wascmdmap_t::value_type(trid, m_pWASListNotice));
    
	m_pWASListNotice->ExecuteAsync();  

	return true;
}

bool CWASActor::RequestListBanner(trid_t *pTrid)
{
	if(!_HasLoginTicket())
		return false;

	trid_t trid = GT_GLOBAL->GetTransactionID(pTrid);

	if(m_pWASListBanner == NULL)
		m_pWASListBanner = new CWASListBanner(this);
    
	if (NULL == m_pWASListBanner)
		return false;

	if(m_pWASListBanner->IsWorking())
		return false;
    
	m_pWASListBanner->SetTransactionID(trid);
	
	m_mapCommand.insert(wascmdmap_t::value_type(trid, m_pWASListBanner));
    
	m_pWASListBanner->ExecuteAsync();  

	return true;
}

bool CWASActor::RequestGetHanatourCount(trid_t *pTrid)
{
	if(!_HasLoginTicket())
		return false;

	trid_t trid = GT_GLOBAL->GetTransactionID(pTrid);

	if(m_pWASGetHanatourCount == NULL)
		m_pWASGetHanatourCount = new CWASGetHanatourCount(this);
    
	if (NULL == m_pWASGetHanatourCount)
		return false;

	if(m_pWASGetHanatourCount->IsWorking())
		return false;
    
	m_pWASGetHanatourCount->SetTransactionID(trid);

	m_mapCommand.insert(wascmdmap_t::value_type(trid, m_pWASGetHanatourCount));

	m_pWASGetHanatourCount->ExecuteAsync();  

	return true;
}

bool CWASActor::RequestListOutLink(trid_t *pTrid)
{
	if(!_HasLoginTicket())
		return false;

	trid_t trid = GT_GLOBAL->GetTransactionID(pTrid);

	if(m_pWASListOutLink == NULL)
		m_pWASListOutLink = new CWASListOutLink(this);
    
	if (NULL == m_pWASListOutLink)
		return false;

	if(m_pWASListOutLink->IsWorking())
		return false;
    
	m_pWASListOutLink->SetTransactionID(trid);
	
	
	m_mapCommand.insert(wascmdmap_t::value_type(trid, m_pWASListOutLink));
    
	m_pWASListOutLink->ExecuteAsync();  

	return true;
}

bool CWASActor::RequestMailCount(trid_t *pTrid )
{
	if(!_HasLoginTicket())
		return false;

	trid_t trid = GT_GLOBAL->GetTransactionID(pTrid);

	if(m_pWASGetMailCount == NULL)
		m_pWASGetMailCount = new CWASGetMailCount(this);

	if (NULL == m_pWASGetMailCount)
		return false;

	if(m_pWASGetMailCount->IsWorking())
		return false;

	m_pWASGetMailCount->SetTransactionID(trid);

	m_mapCommand.insert(wascmdmap_t::value_type(trid, m_pWASGetMailCount));

	m_pWASGetMailCount->ExecuteAsync();  

	return true;
}

bool CWASActor::RequestMailPreview(ULONGLONG ulMailSerial, trid_t *pTrid)
{
	if(!_HasLoginTicket())
		return false;

	trid_t trid = GT_GLOBAL->GetTransactionID(pTrid);

	if(m_pWASGetMailPreview == NULL)
		m_pWASGetMailPreview = new CWASGetMailPreview(this);

	if (NULL == m_pWASGetMailPreview)
		return false;

	if(m_pWASGetMailPreview->IsWorking())
		return false;

	m_pWASGetMailPreview->SetTransactionID(trid);
	m_pWASGetMailPreview->SetParameter(ulMailSerial);

	m_mapCommand.insert(wascmdmap_t::value_type(trid, m_pWASGetMailPreview));

	m_pWASGetMailPreview->ExecuteAsync();  

	return true;
}

bool CWASActor::RequestSMS(LPCWSTR strContent, LPCWSTR strToTelNo, LPCWSTR strFromTelNo, trid_t *pTrid)
{
	if(!_HasLoginTicket())
		return false;

	trid_t trid = GT_GLOBAL->GetTransactionID(pTrid);

	if( NULL == m_pWASSMS)
		m_pWASSMS = new CWASSMS(this);

	if (NULL == m_pWASSMS)
		return false;

	if(m_pWASSMS->IsWorking())
		return false;

	m_pWASSMS->SetTransactionID(trid);
	m_pWASSMS->SetParameter(strToTelNo, strFromTelNo, strContent);

	m_mapCommand.insert(wascmdmap_t::value_type(trid, m_pWASSMS));

	m_pWASSMS->ExecuteAsync();  

	return true;
}

bool CWASActor::RequestSetLanguage(LPCWSTR strLanguage, trid_t *pTrid)
{
	if(!_HasLoginTicket())
		return false;

	trid_t trid = GT_GLOBAL->GetTransactionID(pTrid);

	if( NULL == m_pWASSetLang)
		m_pWASSetLang = new CWASSetLang(this);

	if (NULL == m_pWASSetLang)
		return false;

	if(m_pWASSetLang->IsWorking())
		return false;

	m_pWASSetLang->SetTransactionID(trid);
	m_pWASSetLang->SetParameter(strLanguage);

	m_mapCommand.insert(wascmdmap_t::value_type(trid, m_pWASSetLang));

	m_pWASSetLang->ExecuteAsync();  

	return true;
}

bool CWASActor::RequestGetLanguage(trid_t *pTrid)
{
	if(!_HasLoginTicket())
		return false;

	trid_t trid = GT_GLOBAL->GetTransactionID(pTrid);

	if( NULL == m_pWASGetLang)
		m_pWASGetLang = new CWASGetLang(this);

	if (NULL == m_pWASGetLang)
		return false;

	if(m_pWASGetLang->IsWorking())
		return false;

	m_pWASGetLang->SetTransactionID(trid);

	m_mapCommand.insert(wascmdmap_t::value_type(trid, m_pWASGetLang));

	m_pWASGetLang->ExecuteAsync();  


	return true;
}
bool CWASActor::RequestChangeNotice(LPCWSTR strURL, LPCWSTR strCorp, trid_t *pTrid /*= NULL*/ )
{
	trid_t trid = GT_GLOBAL->GetTransactionID(pTrid);

	if (m_pWASChangeNotice == NULL)
		m_pWASChangeNotice = new CWASChangeNotice(this);

	if(m_pWASChangeNotice->IsWorking())
		m_pWASChangeNotice->CancelCommand();
	m_pWASChangeNotice->SetParameter(strURL, strCorp);

	m_pWASChangeNotice->SetTransactionID(trid);

	m_mapCommand.insert(wascmdmap_t::value_type(trid, m_pWASChangeNotice));

	m_pWASChangeNotice->ExecuteAsync();

	return true;

}

bool CWASActor::RequestCheckUpNotice(LPCWSTR strURL, trid_t *pTrid /*= NULL*/ )
{
	trid_t trid = GT_GLOBAL->GetTransactionID(pTrid);

	if (m_pWASCheckUpNotice == NULL)
		m_pWASCheckUpNotice = new CWASCheckUpNotice(this);

	if(m_pWASCheckUpNotice->IsWorking())
		m_pWASCheckUpNotice->CancelCommand();
	m_pWASCheckUpNotice->SetParameter(strURL);

	m_pWASCheckUpNotice->SetTransactionID(trid);

	m_mapCommand.insert(wascmdmap_t::value_type(trid, m_pWASCheckUpNotice));

	m_pWASCheckUpNotice->ExecuteAsync();

	return true;

}

//////////////////////////////////////////////////////////////////////////////////////////////////

void CWASActor::OnGTManagementEvent_DeleteActor(CActor *pActor)
{
	//  Ŀǵ忡 !

	wascmdmap_t::iterator it = m_mapCommand.begin();
	for(; it != m_mapCommand.end(); it++)
	{
		it->second->OnWASActor_DeletedActor(pActor);
	}
}


//////////////////////////////////////////////////////////////////////////////////////////////////

LPCWSTR CWASActor::GetLastErrorString(trid_t trid)
{
	wascmdmap_t::iterator it = m_mapCommand.find(trid);

	if(it == m_mapCommand.end())
	{
		return _T("");
	}

	CWASCommand *pCommand = dynamic_cast<CWASCommand*>(it->second);
	if(pCommand == NULL)
		return _T("");

	return pCommand->GetErrorString();
}


bool CWASActor::GetPenaltyResultInfo(trid_t trid, GT_PENALTY_RESULT_DATA &sPenaltyResult)
{
	waspenaltyresultmap_t::iterator it = m_mapPenaltyResult.find(trid);
	
	if(it == m_mapPenaltyResult.end())
		return false;
	
	it->second.Convert(sPenaltyResult);
	
	return true;
}


bool CWASActor::GetCacheResultInfo(trid_t trid, GT_CACHE_SERIAL_DATA &sResult)
{
	wascacheresultmap_t::iterator it = m_mapCacheResult.find(trid);
	
	if(it == m_mapCacheResult.end())
		return false;
	
	sResult = it->second;
	
	return true;
}

bool CWASActor::GetContentProgressInfo(trid_t trid, size_t &totalSize, size_t &currentSize)
{
    wascmdmap_t::iterator it = m_mapCommand.find(trid);
    
	if(it == m_mapCommand.end())
	{
		return false;
	}
    
	CWASCommand *pCommand = dynamic_cast<CWASCommand*>(it->second);
	if(pCommand == NULL)
    {
        return false;
    }
    
    return pCommand->GetProgressInfo(totalSize, currentSize);
}

void CWASActor::SetWASServerAddress(const WSTRING& strServerAddr)
{
	//m_strServerAddr.copy(strServerAddr, strServerAddr.size());
	m_strServerAddr = strServerAddr;
}

LPCWSTR CWASActor::GetWASServerAddress()
{
	return m_strServerAddr.c_str();
}

bool CWASActor::ReleaseCommand(trid_t trid)
{
	wascmdmap_t::iterator it = m_mapCommand.find(trid);

	if(it == m_mapCommand.end())
		return false;

	it->second->CompleteCommand();
	m_mapCommand.erase(it);

	return true;
}


bool CWASActor::DeleteCommand(trid_t trid)
{
	wascmdmap_t::iterator it = m_mapCommand.find(trid);

	if(it == m_mapCommand.end())
		return false;

	it->second->CompleteCommand();
	delete it->second;
	m_mapCommand.erase(it);

	//   Ŀǵ带 ϴ ʿ ..
	// ߿ α׷ Ǿ  ִ Ŀǵ带  Ͽ ޸  ֱ .
	wascmdmap_t::iterator it2 = m_mapCommandForDynamic.find(trid);
	if(it2 != m_mapCommandForDynamic.end())
		m_mapCommandForDynamic.erase(it2);

	return true;
}


bool CWASActor::CancelCommand(trid_t trid)
{
	wascmdmap_t::iterator it = m_mapCommand.find(trid);

	if(it == m_mapCommand.end())
		return false;

	it->second->CancelCommand();

	return true;
}


void CWASActor::SavePenaltyResult(trid_t trid, const P_GT_PENALTY_RESULT_DATA &sResult)
{
	std::pair<waspenaltyresultmap_t::iterator, bool> result = m_mapPenaltyResult.insert(waspenaltyresultmap_t::value_type(trid, sResult));
	
	result.first->second = sResult;
}

void CWASActor::DeleteCacheResult(trid_t trid)
{
	wascacheresultmap_t::iterator it = m_mapCacheResult.find(trid);
	
	if(it == m_mapCacheResult.end())
		return;
	
	m_mapCacheResult.erase(it);
}

void CWASActor::SaveCacheResult(trid_t trid, const GT_CACHE_SERIAL_DATA &sResult)
{
	std::pair<wascacheresultmap_t::iterator, bool> result = m_mapCacheResult.insert(wascacheresultmap_t::value_type(trid, sResult));
	
	result.first->second = sResult;
}

const FILE_UPLOAD_RESULT_DATA* CWASActor::RequestUploadFileParsing( std::string &strJson )
{
	
	m_fileUploadData.nErrCode =0;
	m_fileUploadData.strErrMsg =L"";
	Json::Value root;
	Json::Reader reader;
	bool bParsingSuccess = reader.parse(strJson, root);
	if (!bParsingSuccess)
		return &m_fileUploadData;
	m_fileUploadData.strResult = Conversion::Utf8ToWide(root.get("Result","").asString());
	m_fileUploadData.strErrMsg = Conversion::Utf8ToWide(root.get("Message","").asString());

	
	return &m_fileUploadData;

}

